﻿using System;
using System.Drawing;

namespace RyzStudio.Windows.ThemedForms
{
	public partial class ProgressBar : RyzStudio.Windows.ThemedForms.UserControl
	{
		public ProgressBar() : base()
		{
			InitializeComponent();

			styleActive = new ThemeStyle(1, 3, 2, Color.FromArgb(212, 212, 212), Color.White);
		}

		public int Minimum { get => userControl1.Minimum; set => userControl1.Minimum = value; }
		public int Maximum { get => userControl1.Maximum; set => userControl1.Maximum = value; }
		public int Value { get => userControl1.Value; set => userControl1.Value = value; }

		public Color BarColour { get => userControl1.BarColour; set => userControl1.BarColour = value; }
		public Color BarTextColour { get => userControl1.BarTextColour; set => userControl1.BarTextColour = value; }

        protected override void OnSizeChanged(EventArgs e)
        {
            base.OnSizeChanged(e);

            this.Invalidate();
        }
    }
}
